<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- android-ndk-module.qdoc -->
  <title>Android.ndk QML Type | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<p class="naviNextPrevious headerNavi">
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#properties">Properties</a></li>
<li class="level1"><a href="#details">Detailed Description</a></li>
<li class="level2"><a href="#relevant-file-tags">Relevant File Tags</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Android.ndk QML Type</h1>
<span class="subtitle"></span>
<!-- $$$Android.ndk-brief -->
<p>Provides support for building native Android libraries. <a href="#details">More...</a></p>
<!-- @@@Android.ndk -->
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> Import Statement:</td><td class="memItemRight bottomAlign"> import QbsModules .</td></tr><tr><td class="memItemLeft rightAlign topAlign"> Since:</td><td class="memItemRight bottomAlign"> Qbs 1.4</td></tr></table></div><ul>
<li><a href="qml-qbsmodules-android-ndk-members.html">List of all members, including inherited members</a></li>
</ul>
<a name="properties"></a>
<h2 id="properties">Properties</h2>
<ul>
<li class="fn"><b><b><a href="qml-qbsmodules-android-ndk.html#abi-prop">abi</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-android-ndk.html#appStl-prop">appStl</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-android-ndk.html#ndkDir-prop">ndkDir</a></b></b> : path</li>
<li class="fn"><b><b><a href="qml-qbsmodules-android-ndk.html#platform-prop">platform</a></b></b> : string</li>
</ul>
<!-- $$$Android.ndk-description -->
<a name="details"></a>
<h2 id="details">Detailed Description</h2>
<p>The <code>Android.ndk</code> module contains the properties and rules to create native libraries for use in Android applications.</p>
<p>Normally, you will not use this module directly, but instead work with the <a href="qml-qbsconvenienceitems-dynamiclibrary.html">DynamicLibrary</a>, <a href="qml-qbsconvenienceitems-staticlibrary.html">StaticLibrary</a> and <a href="qml-qbsconvenienceitems-application.html">Application</a> items that Qbs provides.</p>
<p>Here is what the project file for the <code>hello-jni</code> example that comes with the NDK could look like:</p>
<pre class="cpp">

  CppApplication {
      name: <span class="string">&quot;HelloJni&quot;</span>
      Android<span class="operator">.</span>sdk<span class="operator">.</span>packageName: <span class="string">&quot;com.example.hellojni&quot;</span>
      qbs<span class="operator">.</span>architectures: <span class="operator">[</span><span class="string">&quot;arm&quot;</span><span class="operator">,</span> <span class="string">&quot;x86&quot;</span><span class="operator">]</span>
      files: <span class="string">&quot;app/src/main/jni/hello-jni.c&quot;</span>
  }

</pre>
<a name="relevant-file-tags"></a>
<h3 id="relevant-file-tags">Relevant File Tags</h3>
<a name="filetags-android-ndk"></a><div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Tag</th><th >Since</th><th >Description</th></tr></thead>
<tr valign="top" class="odd"><td ><code>&quot;android.nativelibrary&quot;</code></td><td >1.4&#x2e;0</td><td >Attached to dynamic libraries that will end up in APK packages. You do not normally need to use the tag explicitly, as it is the default type of the <a href="qml-qbsconvenienceitems-dynamiclibrary.html">DynamicLibrary</a> item for Android targets.</td></tr>
</table></div>
<!-- @@@Android.ndk -->
<h2>Property Documentation</h2>
<!-- $$$abi -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="abi-prop">
<td class="tblQmlPropNode"><p>
<span class="name">abi</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The ABI name as it appears under <code>&quot;lib/&quot;</code> in the application package. Corresponds to <code>APP_ABI</code> in <code>Android.mk</code>.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@abi -->
<br/>
<!-- $$$appStl -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="appStl-prop">
<td class="tblQmlPropNode"><p>
<span class="name">appStl</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The library to use for C++. The possible values are:</p>
<ul>
<li><code>&quot;c++_shared&quot;</code></li>
<li><code>&quot;c++_static&quot;</code></li>
</ul>
<p>Default: <code>&quot;c++_shared&quot;</code></p>
</div></div><!-- @@@appStl -->
<br/>
<!-- $$$ndkDir -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="ndkDir-prop">
<td class="tblQmlPropNode"><p>
<span class="name">ndkDir</span> : <span class="type">path</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The NDK base directory.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@ndkDir -->
<br/>
<!-- $$$platform -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="platform-prop">
<td class="tblQmlPropNode"><p>
<span class="name">platform</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The versioned platform name.</p>
<p>Default: <code>&quot;android-16&quot;</code> for 32 bit arm ABIs and <code>&quot;android-21&quot;</code> for all 64 bit ABIs and x86. x86 ABI has broken wstring support in android-16 to android-19.</p>
</div></div><!-- @@@platform -->
<br/>
<p class="naviNextPrevious footerNavi">
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
